#pragma once
//  QFeedRequest
//
//  This class extends the standard DXRequest class to carry additional information needed by the
//  QMFeeder processing exit.
//
//  Message Identifier:      N/A
//  Message Range:           0000 - 0000
//  Trace area assignment:   None
//  Version:                 1.4.2  Build: 37
//
//  Version History:
//
//  1.4.0		04/11/2010   -  Asynch transcation queue handler added.
// 								Incorporated RunTime (3.10.1) changes.
//  1.4.2		22/10/2011	 -	VS 2011 Updates
//
//  Copyright: Hadleigh Marshall (Netherlands) b.v. 2010 - 2011
//

//  Runtime Includes
#include "../DXCommon/MTDX/DXRequest.h"

//  Application Includes
#include "QMoveRequest.h"									//  QMove Request object

class QFeedRequest :
	public DXRequest
{
public:
	//  Default Constructor
	QFeedRequest(void);

	//  Destructor
	~QFeedRequest(void);

	//  Public Memebers
	HANDLE				hTXLog;								//  Handle to the transaction log
	DWORD				dwTransactionsCreated;				//  Count of transactions created
	QMoveRequest		*qmrFeeder;							//  Pointer to the feeder request

	//  Public Functions
	using DXRequest::InheritFrom;
	using DXRequest::CreateNewInstance;
	using DXRequest::PromoteScores;
	virtual DXRequest * CreateNewInstance(void);			//  Create a new instance
	virtual void InheritFrom(DXRequest *dxrParent);			//  Inherit context from parent request
	virtual void PromoteScores(DXRequest *dxrParent);		//  Promote scores to parent request
};
