//     Q(ueue)Move - Queued database mover

//  Platform Includes
#include	"../DXCommon/Platform/PlatBase.h"		//  Basic platform includes

//  Runtime Includes
#include	"../DXCommon/MTX/MTExecutive.h"			//  Multi-Threading Runtime environment
#include	"../DXCommon/MTX/MTExecutive.h"			//  Multi-Threading Runtime environment
#ifdef _DEBUG
#include	"../DXCommon/Debug/Helper.h"			//  Debugging Helper
#endif

//  Application Includes
#include	"AppRunSettings.h"						//  Application Run Settings
#include	"AppCommandHandler.h"					//  Application MQ command handler
#include	"AppTransactionHandler.h"				//  Transaction Queue Handler
#include	"QMover.h"								//  Database Mover
#include	"QMFeeder.h"							//  Queue Feeder Transaction Handler

//  Additional Notes Includes
#include <stats.h>

//  Identification Constants
#define		APP_NAME				"QMove"
#define		APP_TITLE				"Database Mover"
#ifdef _DEBUG
#define		APP_VERSION				"1.4.2 build: 39 Debug"
#else
#ifdef _DXIP
#define		APP_VERSION				"1.4.2 build: 39 Instrumented"
#else
#define		APP_VERSION				"1.4.2 build: 39"
#endif
#endif
#define		QMQNAME					"QMove Queue #1"		//  Transaction Queue Name

//  Application Constants

//  Return codes
#define		APPRC_NOERROR			0				//  Everything copacetic
#define		APPRC_WARN				4				//  Execution ok, but warnings issued
#define		APPRC_ERROR				8				//  Execution completed with errors
#define		APPRC_FATAL				16				//  Execution could not be completed

//  Wait, timeout and other intervals and limits
#define		TIMEOUT_EVENT_WAIT		5000			//  5 seconds delay in idle state

//  Add-In tesk status
#define		ADDIN_STATUS_RUNNING		"Running"
#define		ADDIN_STATUS_TERM			"Shutting Down"

//  Queue Names
#define		QUEUE_NEW_TRANS_VIEW		"NewTransactions"
#define		QUEUE_DELAYED_TRANS_VIEW	"DelayedTransactions"
#define		QUEUE_IP_TRANS_VIEW			"InProgressTransactions"

//  Miscellaneous definitions
#define		PCAP_PERTHREAD		20				//  Allow capacity for 20 pending requests per thread
#define		RCAP_PERTHREAD		20				//  Allow capacity for 20 rejoin requests per thread

//  Error Messages
#define		MSG_QMV0101S			"QMV0101S: Unable to start program execution."
#define		MSG_QMV0103S			"QMV0103S: Unable to close the application execution environment."

//  Warning Messages

//  Information Messages
#define		MSG_QMV0102I			"QMV0102I: Using Runtime Version: %s."
#define		MSG_QMV0105I			"QMV0105I: QMove has recieved a Quit signal from the message queue."
#define		MSG_QMV0106I			"QMV0106I: Transaction queue '%s' has drained."
#define		MSG_QMV0107I			"QMV0107I: QMove has recieved a Quit signal from the message queue."
#define		MSG_QMV0108I			"QMV0108I: QMove is shutting down."
#define		MSG_QMV0109I			"QMV0109I: QMove is running with the Large File (asynchronous) copier disabled."
#define		MSG_QMV0110I			"QMV0110I: QMove will use an Arena Size of %i Mb and a Copy Buffer of %i Kb."

//  Function Prototypes / Forward declarations


