#pragma once
//  QMover
//
//  This class extends the DX DbMover class to provide additional Database Move services that
//  are needed by the QMove application.
//
//  Version:                 1.4.2  Build: 37
//
//  Version History:
//
//  1.0.0		- 14/11/2009			Initial Version
//  1.1.0		- 01/12/2009		-	Enhanced move operation modes supported
//  1.2.0		- 01/01/2010		-	Variable delay between transactions
//									-	Variable buffer size for copying
//  1.4.0		- 15/11/2010		-   MTIO support added
//  1.4.2		- 22/10/2011		-	VS 2011 Updates
//
//  Copyright: Hadleigh Marshall (Netherlands) b.v. 2009 - 2011
//

//  Application Includes
#include "../DXCommon/DBC/DbMover.h"
#include "QMoveRequest.h"

//  Additional notes API inclides
#include <textlist.h>

//  Miscellaneuos Definition
#define		HISTORY_MUTEX			APP_MUTEX_1			//  Define the history Mutex
#define		LOG_TRUNCATED_MSG		"....Transaction Log Truncated ......."

//  Error Messages
#define		MSG_QMV0501E			"QMV0501E: An error was encountered while logging to the request document."
#define		MSG_QMV0502E			"QMV0502E: Transaction History logging has been suspended."
#define		MSG_QMV0503E			"QMV0503E: Unable to add a line to the transaction history log, the log is truncated."

//  Miscellaneuos Definition

class QMover :
	public DbMover
{
public:
	//  Constructor
	QMover(MTExecutive *xeParent, int iThreadID);

	//  Destructor
	~QMover(void);

	//  Public Members
	HANDLE		htlHistory;																	//  Handle history text list

protected:
	//  Protected Members
	BOOL virtual ProxyLogMessage(MoveRequest *mrRQ, char *szMsg, int iThreadID);			//  Proxry Log interface
};
